#include <Python.h>
#include "ngexec.h"

static PyObject * numJobsWantedGlue (PyObject * self, PyObject * args) {
  char * inxml = NULL;
  if (!PyArg_ParseTuple (args, "z", &inxml)) return NULL;
  char * outxml = numJobsWanted (inxml);
  PyObject * obj = Py_BuildValue("z", outxml);
  if (outxml) free (outxml);
  return obj;
}

static PyObject * executeJobsGlue (PyObject * self, PyObject * args) {
  char * inxml = NULL;
  if (!PyArg_ParseTuple (args, "z", &inxml)) return NULL;
  char * outxml = executeJobs (inxml);
  PyObject * obj = Py_BuildValue("z", outxml);
  if (outxml) free (outxml);
  return obj;
}

static PyObject * getExecutorDataGlue (PyObject * self, PyObject * args) {
  char * inxml = NULL;
  if (!PyArg_ParseTuple (args, "z", &inxml)) return NULL;
  char * outxml = getExecutorData (inxml);
  PyObject * obj = Py_BuildValue("z", outxml);
  if (outxml) free (outxml);
  return obj;
}

static PyObject * getStatusGlue (PyObject * self, PyObject * args) {
  char * inxml = NULL;
  if (!PyArg_ParseTuple (args, "z", &inxml)) return NULL;
  char * outxml = getStatus (inxml);
  PyObject * obj = Py_BuildValue("z", outxml);
  if (outxml) free (outxml);
  return obj;
}

static PyObject * fixJobsGlue (PyObject * self, PyObject * args) {
  char * inxml = NULL;
  if (!PyArg_ParseTuple (args, "z", &inxml)) return NULL;
  char * outxml = fixJobs (inxml);
  PyObject * obj = Py_BuildValue("z", outxml);
  if (outxml) free (outxml);
  return obj;
}

static PyObject * killJobsGlue (PyObject * self, PyObject * args) {
  char * inxml = NULL;
  if (!PyArg_ParseTuple (args, "z", &inxml)) return NULL;
  char * outxml = killJobs (inxml);
  PyObject * obj = Py_BuildValue("z", outxml);
  if (outxml) free (outxml);
  return obj;
}

static PyMethodDef NorduGridMethods[] = {
  {"numJobsWanted", numJobsWantedGlue, METH_VARARGS, ""},
  {"executeJobs", executeJobsGlue, METH_VARARGS, ""},
  {"getExecutorData", getExecutorDataGlue, METH_VARARGS, ""},
  {"getStatus", getStatusGlue, METH_VARARGS, ""},
  {"fixJobs", fixJobsGlue, METH_VARARGS, ""},
  {"killJobs", killJobsGlue, METH_VARARGS, ""},
  {NULL, NULL, 0, NULL}
};

extern "C" void initnordugrid (void) {

  Py_InitModule ("nordugrid", NorduGridMethods);
};
